NewObject (API documentation of hlt.language packages)
Date: 2013-01-30

hlt.language.design.kernel

## Class NewObject

- java.lang.Object
- - hlt.language.design.kernel.Expression
  - - hlt.language.design.kernel.ProtoExpression
    - - hlt.language.design.kernel.Constant
      - - hlt.language.design.kernel.NewObject

- All Implemented Interfaces:
    Locatable

      public class NewObject
      extends Constant

  This is the class of 'new' object expressions.

- - ### Field Summary

    - ### Fields inherited from class hlt.language.design.kernel.Constant

      `UNWRAP_INT, UNWRAP_REAL, VOID, WRAP_INT, WRAP_REAL`

    - ### Fields inherited from class hlt.language.design.kernel.Expression

      `VOID_ASSIGNMENTS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `NewObject(Type type)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `compile(Compiler compiler)` This method compiles this expression in the context of the specified `Compiler`.
    `java.lang.String` | `toString()`
    `void` | `typeCheck(TypeChecker typeChecker)` This method type-checks this expression in the context of the specified `TypeChecker`.

    - ### Methods inherited from class hlt.language.design.kernel.Constant

      `copy, equals, FALSE, initialize, isFalse, isNull, isTrue, NULL, NULL, setCheckedType, setIsNull, TRUE, typedCopy`

    - ### Methods inherited from class hlt.language.design.kernel.ProtoExpression

      `checkedType, setCheckedType, setType, type, typeRef`

    - ### Methods inherited from class hlt.language.design.kernel.Expression

      `addType, addTypes, boxSort, containsFreeName, enclosingScope, extent, getEnd, getStart, isConstant, isEquality, isHiddenSlicing, isSelector, isSlicing, isVoid, locationString, numberOfSubexpressions, otherTypes, parameters, sanitizeNames, sanitizeSorts, setCheckedTypeLocked, setEnd, setExtent, setOtherTypes, setStart, setSubexpression, shiftOffsets, shiftOffsets, sort, subexpression, substitute, typeCheck, typeCheck, typeCheckLocked`

    - ### Methods inherited from class java.lang.Object

      `getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### NewObject

          public NewObject(Type type)

  - ### Method Detail

    - #### typeCheck

          public final void typeCheck(TypeChecker typeChecker)
                               throws TypingErrorException

      Description copied from class: `Expression`
      This method type-checks this expression in the context of the specified `TypeChecker`.
      Overrides:
        `typeCheck` in class `Constant`
      Throws:
        `TypingErrorException`

    - #### compile

          public final void compile(Compiler compiler)

      Description copied from class: `Expression`
      This method compiles this expression in the context of the specified `Compiler`.
      Overrides:
        `compile` in class `Constant`

    - #### toString

          public final java.lang.String toString()

      Overrides:
        `toString` in class `Constant`